;
;
;
;
;
;
;
;
;  backgrnd.asm
;
;  usage:
;	    extern init_bkg( int (*routine)(), char *stack, int stacklen)
;	    extern swap_bkg()
;	    extern kill_bkg()
;
;  (c) 1990 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;
	org	$
	idt	backgrnd

SETVEC	equ	25h		; function to set interrupt vector
GETVEC	equ	35h
TICKER	equ	1ch
DOS	equ	21h


oldint	dw 0,0

inside	db 0
stkbase dw 0		; used to check stack depth
stkptr	dw 0
stkseg	dw 0
retstk	dw 0,0
bkgptr	dw 0, 0

swapstk macro
	cli
	mov	AX, SS
	xchg	ax,CS:[stkseg]
	mov	SS, AX
	xchg	sp,CS:[stkptr]
	sti
	endm

	; note, we do not push AX!!!!!!, assembly routine must
push_em	macro
	push	BX
	push	CX
	push	DX
	push	BP
	push	SI
	push	DI
	push	DS
	push	ES
	endm

pop_em	macro
	pop	ES
	pop	DS
	pop	DI
	pop	SI
	pop	BP
	pop	DX
	pop	CX
	pop	BX
	pop	AX
	endm

	; bkg_int - the interrupt function called by the timer tick
	ldef	bkg_int
bkg_int:
	; first chain
	pushf
;	call	dword ptr CS:[oldint]
	push	cs:[oldint+2]
	push	cs:[oldint]
	retfar

	; establish if we are active
	push	AX
	mov	AL, 1
	xchg	al,CS:[inside]
	or	AL, AL
	jz	@1		; not busy, go ahead

	; must be already active
	pop	AX
	iret

@1:	push_em

	; switch over to the new stack
	swapstk

	pop_em

	retfar

	; use cproc, does not use BP
	ldef	swap_bkg
swap_bkg:
	push	bp
	mov	bp,sp
	push	AX
	push_em   		; save them on
	swapstk
	pop_em

	xor	AL, AL		; clear flag
	mov	CS:[inside], AL

	iret

	ldef	init_bkg
init_bkg:; int (*routine)(), char *stack, int stacklen
	push	bp
	mov	bp,sp

	; get pointer to routine
	mov	DX, [BP+6]
	mov	CS:[bkgptr], DX
	mov	CX, [BP+8]
	mov	CS:[bkgptr+2], CX

	; get stack area
	mov	AX, [BP+10]
	mov	CS:[stkbase], AX
	mov	CS:[stkseg], DS

	; get length
	add	AX, [BP+12]
	sub	AX, 2
	mov	CS:[stkptr], AX

	; get the stack area and set up the first call
	swapstk
	push	CX
	push	DX
	push	AX
	push_em

	; done with that stack
	swapstk

	; set up the interrupt
	push	ES
	push	DS
	mov 	AH, GETVEC
	mov	AL, TICKER
	int	DOS
	mov	word ptr CS:[oldint], BX
	mov	word ptr CS:[oldint+2], ES

	mov	ax,cs
	mov	ds,ax
	mov	DX, offset bkg_int
	mov	AH, SETVEC
	mov	AL, TICKER
	int	DOS

	mov	DS, DX

	pop	DS
	pop	ES
	xor 	AX, AX
	pop	bp
	retfar

	ldef	kill_bkg
kill_bkg:
	push	bp
	mov	bp,sp
	push	DS
	xor	AX, AX
	mov	DS, AX
	mov	BX, TICKER * 4
	cli
	mov	CX, word ptr CS:[oldint]
	mov	DX, word ptr CS:[oldint+2]
	mov	DS:[BX], CX
	mov	DS:[BX+2], DX
	sti
	pop	DS
	pop	bp
	retfar

        end


