/***
 * Filke: cout.c
 *
 * 16-Jun-92 lr
 * various output functions used for debugging and error messages
 ***/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

#define	FALSE	0
#define	TRUE	1

static void _putchar(unsigned char ch)
	{
	fputc(ch, stderr) ;
	}

void (*_outch)(unsigned char) = _putchar ;

void outch(unsigned char ch )
	{
	(*_outch)(ch) ;
	}

void outs(unsigned char *s)
	{
	while (*s) outch(*s++) ;
	}       

void outsn(unsigned char *s, unsigned n)
	{
	while (n--) outch(*s++);
	}

void outhex(unsigned char ch )
	{
	unsigned char c;
		
	outch( (unsigned char) ((c=(unsigned char) (ch/16)) > 9 ?
					c + 'A' - 10: c + '0'));
	outch( (unsigned char) ((c=(unsigned char) (ch%16)) > 9 ?
					c + 'A' - 10: c + '0'));
	}

/*
 * outhexes - dump n hex bytes to stdio
 *
 */
void outhexes(unsigned char *p, unsigned n )
	{
	while ( n-- > 0)
		{
		outhex( *p++) ;
		outch(' ') ;
		}
	}

void outfmt(char *format, ...)	/* Handle: %#c, %#s, %#ld, %#lx, %#lu */
	{
	static char bfr[100] ;
	int dubl, upper, ljust, rjust, base ;
	int len, width ;
	char c ;
	va_list arg ;

	va_start(arg, format) ;
	while (c = *format++)
		{
		if (c == '%')
			{
			width = atoi(format) ;
			while ((c = *format) && isdigit(c)) format++ ;
			c = *format ;
			if (!c) break ;
			dubl = tolower(c) == 'l' ;
			if (dubl) format++ ;
			c = *format++ ;
			if (!c) break ;
			upper = FALSE ;
			base = 10 ;
			ljust = rjust = 0 ;
			switch (tolower(c))
				{
				case 'c':
					bfr[0] = (char) va_arg(arg, int) ;
					bfr[1] = '\0' ;
					break ;

				case 's':
					strncpy(bfr, va_arg(arg, char *),
						sizeof(bfr) - 1) ;
					bfr[sizeof(bfr) - 1] = '\0' ;
					ljust = 1 ;
					break ;

				case 'x':
					upper = isupper(c) ;
					base = 16 ;

				case 'd':
				case 'u':
					if (dubl)
						{
						long l ;

						l = va_arg(arg, long) ;
						ltoa(l, bfr, base) ;
						}
					else
						{
						int i ;

						i = va_arg(arg, int) ;
						itoa(i, bfr, base) ;
						}
					rjust = 1 ;
					break ;

				default:
					strcpy(bfr, "") ;
					break ;
				}

			if (upper) strupr(bfr) ;
			len = strlen(bfr) ;
			if (rjust) while (len++ < width) outch(' ') ;
			outs((unsigned char *) bfr) ;
			if (ljust) while (len++ < width) outch(' ') ;
			}

		else outch(c) ;
		}

	va_end(arg) ;
	}

/*** end of file cout.c ***/
