;
;  DESQVIEW.ASM
;
	org	$
	idt	desqview

;*************************************************************************
;  Usage:  word dv_vers(void)  /* Returns version # if DV present, else 0
;*************************************************************************

; Returns in AH/AL the DESQview major/minor version numbers,
; Returns 0 in AX if DESQview isn't there.

	ldef	dv_vers
dv_vers:mov     cx,'DE'         ; set CX to 4445h; DX to 5351h
        mov     dx,'SQ'         ; (an invalid dat)
        mov     ax,2B01h        ; DOS' set date function
        int     21h             ; Call DOS
        cmp     al,0FFh         ; Did dos see it as invalid?
	mov	ax,0		; (presume DV not present)
        je      dv_done         ; If so, Desqview isn't there
        mov     ax,bx           ; AH=major version; AL=minor vers
dv_done:retfar

;*************************************************************************
;  Usage:  word dv_vseg(word)  /* Presumes DV is present */
;*************************************************************************

	ldef	dv_vseg
dv_vseg:push	bp
	mov	bp,sp
	mov	es,[bp+6]	; video segment we want B000/B800
	mov	ah,0FEh
	int	10h
	mov	ax,es		; video segment to use
	pop	bp
	retfar

;*************************************************************************
;  Usage:  void dv_yield(void)  /* Presumes DV is present */
;*************************************************************************

; If the program waits for input when it's idle, DESQview won't
; waste any processor time on it until the user types the next key.
; However, if the program sits in a loop polling the keyboard
; when it's basically idle, you'll probably want to use the
; DV_PAUSE call to relinquish the remainder of your time slice
; when you see that the event you're polling for hasn't yet occurred.
; This minimizes the amount that the program's polling loop affects
; other programs running in background.

; Notes:
; This routine tells DESQview to slice away from your program
; Takes no parameters and returns nothing.

	ldef	dv_yield
dv_yield:
	mov     ax,1000h        ; DV yield function
        int     15h             ; Make that call
        retfar

;*************************************************************************
;  Usage:  void os_yield(void)	; Works with DOS, MS/Win, OS/2, DPMI.
;*************************************************************************
	ldef	os_yield
os_yield:
	mov	ax,1680h
	int	2Fh
	retfar

;*************************************************************************
;  Usage:  BOOL int2Fok(void)	; Works with DOS, MS/Win, OS/2, DPMI.
;*************************************************************************
	ldef	int2Fok
int2Fok:
	mov	ax,1680h
	int	2Fh
	or	al,al
	mov	ax,0
	jnz	int2Fdone
	inc	ax
int2Fdone:
	retfar

;*************************************************************************
;  Usage:  void int28(void)	; Yield of last resort
;*************************************************************************
	ldef	int28
int28:
	int	28h
	retfar

	end
