;
;
;
;
;
;  net_string - find a network string from a buffer
;
;
;  (c) 1992 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;
;
	org	$
	idt	strings

;*************************************************************************
;  USAGE:  int net_string( byte *buf, int buflen, byte *strbuf, int strbuflen )
;  ALL POINTERS ASSUMED FAR
;*************************************************************************
	ldef	net_string
net_string:
	push	bp
	mov	bp,sp

        push    DS
        push    ES
        cld

        lds     SI, [BP+6]
        mov     BX, [BP+10]
        les     DI, [BP+12]
        mov     CX, [BP+16]

        cmp     CX, BX          ; find the lesser, ie. max string len
        ja      l0
        mov     CX, BX

l0:     sub     CX, 2           ; must leave room for the '\0'
        mov     BX, CX          ; need later

l1:     lodsb                   ; check each character to see if
        cmp     AL, 0eh         ; it is the string terminator
        jb      l3              ; a likely suspect is investigated
l2:     stosb
        loop    l1
        jcxz    l4              ; quite done
                                ; (MS-ASM generates phase error if we use JMP
                                ; phase-error? Get a life Microsoft, figuring
                                ; out the distance is pretty darn trivial,
                                ; even DEBUG can do it!)

l3:     cmp     AL, 0ah         ; <lf>
        je      l4
        cmp     AL, 0dh         ; <cr>
        jne     l2              ; no, so continue

        ; this is still for <cr>, we erase the next character
        jcxz    l5              ; no more characters - line incomplete
        dec     CX
        jmp     l4

        ; here we handle case when we didn't find a string
l5:

l4:     xor     AL, AL
        stosb

        ; now must return length of string to remove
        mov     AX, BX
        sub     AX, CX
l6:     pop     ES
        pop     DS
	pop	bp
	retfar

        end
