;
;
;  Usage :
;	    -pktentry
;           _pktasminit( void far * buffers, int maxbufs, int buflen)
;
;  (c) 1991 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;  version
;
;    0.1    22-May-1992   E. P. Engelke
;
;
	org	$
	idt	asmpkt

maxbufs	dw	0
maxlen	dw	0
bufs	dw	0
bufseg	dw	0
swapped	dw	0	; NZ => buffers are swapped out

	ldef	_pktentry
_pktentry:
	pushf
	cli		; no interruptions now

	cmp	AL,01h
	je	encue	; branch if was a 1 and must encue packet now

	cmp	AL,00h
	jne	no_enqu

	; buffer request operation
	; to check our buffers we will need the same DS seg, set it now

        push    CX
        mov     ES, CS:[bufseg]

	; check the packet length
	cmp	CX, CS:[maxlen]
	ja	no_fnd		; pretend none were found

	cmp	CS:[swapped],0
	jne	no_fnd

	mov	DI, CS:[bufs]
	mov	CX, CS:[maxbufs]

srcloop:cmp     BYTE PTR ES:[DI],0
	je	found
	add	DI, CS:[maxlen]
	inc	DI
	inc	DI
	loop	srcloop

no_fnd: xor	DI, DI		; for whatever error, throw away the buffer
	mov	ES, DI		; by returning 0000:0000
	pop	CX
	popf
	retfar

found:  mov	BYTE PTR ES:[DI],2	; mark buffer as busy
	inc	DI
	inc	DI
	pop	CX
	popf
	retfar

	; encue packet
	;
encue:	or	SI, SI
	jz	no_enqu		; not a valid pointer, cannot encue
        mov     BYTE PTR DS:[SI][-2],1	; mark as filled and waiting
no_enqu:popf
	retfar

	ldef	_pktasminit
_pktasminit:		; bufptr, maxbufs, buflen
	push	bp
	mov	bp,sp
	mov	AX, [BP+6]	; bufptr
	mov	BX, [BP+8]	; bufptr segment
	mov	CX, [BP+10]	; maxbufs
	mov	DX, [BP+12]	; buflen
	mov	CS:[bufs], AX
	mov	CS:[bufseg], BX
	mov	CS:[maxbufs], CX
	mov	CS:[maxlen], DX

	pop	bp
	retfar

	ldef	_pkt_swapped
_pkt_swapped:
	mov	CS:[swapped],AX
	retfar

        end
