/*
	File: BLOCKED.C
*/

#include <wattcp.h>

int Blocked(long ip, char *blocked_ip_list)
	{
	static long previous = -1L ;
	static int blocked = FALSE ;
	char bfr[100] ;
	FILE *fp ;

	if (!blocked_ip_list) return FALSE ;

	if (ip == previous) return blocked ;

	previous = ip ;
	blocked = FALSE ;

	fp = fopen(blocked_ip_list, "r") ;
	if (!fp) Abort("Can't open file", blocked_ip_list) ;

	while (!blocked && fgets(bfr, sizeof(bfr), fp))
		{
		rip(bfr) ;
		if (!isaddr(bfr))
			{
			Abort("Blocked host not specified by IP address",
				bfr) ;
			}

		blocked = resolve(bfr) == ip ;
		}

	fclose(fp) ;
	return blocked ;
	}

int Allowed(long ip, char *allowed_ip_list)
	{
	static long previous = -1L ;
	static int allowed = TRUE ;
	char bfr[100] ;
	FILE *fp ;

	if (!allowed_ip_list) return TRUE ;

	if (ip == previous) return allowed ;

	previous = ip ;
	allowed = FALSE ;

	fp = fopen(allowed_ip_list, "r") ;
	if (!fp) Abort("Can't open file", allowed_ip_list) ;

	while (!allowed && fgets(bfr, sizeof(bfr), fp))
		{
		rip(bfr) ;
		if (!isaddr(bfr))
			{
			Abort("Allowed host not specified by IP address",
				bfr) ;
			}

		allowed = resolve(bfr) == ip ;
		}

	fclose(fp) ;
	return allowed ;
	}
