#include <copyright.h>
#include <stdio.h>
#include <wattcp.h>
#include <stdlib.h>    /* itoa */
#include <string.h>
#include <elib.h>

/*
 * PCBSD - provide some typical BSD UNIX functionality
 * Erick Engelke, Feb 22, 1991
 */

/*
 * chk_socket - determine whether a real socket or not
 *
 */
_chk_socket(tcp_Socket *s)
	{
	switch (s->ip_type)
		{
		case TCP_PROTO:
			/* skips invalid data */
			return (s->state <= tcp_StateCLOSED) ? 2 : -1 ;

		case UDP_PROTO:
			return TRUE ;
		}

	return FALSE ;
	}

char *inet_ntoa(char *s, longword x)
	{
#ifndef	DWL
	sprintf(s, "%u.%u.%u.%u",
		((char *) &x)[3],
		((char *) &x)[2],
		((char *) &x)[1],
		((char *) &x)[0]) ;
#else
	itoa(x >> 24, s, 10) ;
	strcat(s, ".") ;
	itoa((x >> 16) & 0xFF, strchr(s, 0), 10) ;
	strcat( s, ".") ;
	itoa((x >> 8) & 0xFF, strchr(s, 0), 10) ;
	strcat(s, ".") ;
	itoa(x & 0xFF, strchr(s, 0), 10) ;
#endif
	return s ;
	}

longword inet_addr(char *s)
	{
	return isaddr(s) ? aton(s) : 0L ;
	}

char *sockerr(tcp_Socket *s)
	{
	return strlen(s->err_msg) < 80 ? s->err_msg : NULL ;
	}

char *sockstate(tcp_Socket *s)
	{
	static char *sock_states[] =
		{
		"Listen",
		"SynSent",
		"SynRec",
		"Established",
		"FinWait",
		"FinWt1",
		"FinWt2",
		"ClosWt",
		"Closing",
		"LastAck",
		"TmWait",
		"CloseMSL",
		"Closed"
		} ;

	switch (_chk_socket(s))
		{
		case -1 : return "Bad TCP/IP socket" ;
		case  1 : return "UDP Socket" ;
		case  2 : return sock_states[s->state] ;
		default : return "Not an active socket" ;
		}
	}

longword gethostid(void)
	{
	return my_ip_addr ;
	}

longword sethostid(longword ip)
	{
	return my_ip_addr = ip ;
	}

word ntohs(word a)
	{
	return intel16(a) ;
	}

word htons(word a)
	{
	return intel16(a) ;
	}

longword ntohl(longword x)
	{
	return intel(x) ;
	}

longword htonl(longword x)
	{
	return intel(x) ;
	}

