#include <copyright.h>
#include <wattcp.h>
#include <mem.h>

int sock_rbsize(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 1 : return tcp_MaxRxSize  ;
		case 2 : return tcp_MaxRxSize  ;
		default: return 0 ;
		}
	}

int sock_rbused(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 1 : return s->rdatalen ;
		case 2 : return s->rdatalen ;
		default: return 0 ;
		}
	}

int sock_rbleft(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 1 : return tcp_MaxRxSize - s->rdatalen ;
		case 2 : return tcp_MaxRxSize - s->rdatalen ;
		default: return 0 ;
		}
	}

int sock_tbsize(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 2 : return tcp_MaxTxSize  ;
		default: return 0 ;
		}
	}

int sock_tbused(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 2 : return s->datalen ;
		default: return 0 ;
		}
	}

int sock_tbleft(tcp_Socket *s)
	{
	switch(_chk_socket(s))
		{
		case 2 : return tcp_MaxTxSize - s->datalen ;
		default: return 0 ;
		}
	}

int sock_preread(sock_type *s, byte *dp, int len)
	{
	int count;

	if ((count = s->udp.rdatalen) < 1)    /* 0 : no data, -1 : error */
		{
		return count ;
		}

	if (count > len) count = len ;
	
	_MEMCPY(dp, s->udp.rdata, count) ;
	return count ;
	}
