/* domain name server protocol
 *
 * This portion of the code needs some major work. I ported it (read STOLE IT)
 * from NCSA and lost about half the code somewhere in the process.
 *
 * Note, this is a user level process.  We include <tcp.h> not <wattcp.h>
 *
 *  0.4 : Dec 10, 1996 - Made re-entrant & reduced stack use (by D. Lewis)
 *  0.3 : Jan  8, 1994 - hooks for different RR types; rev lookups. messy!
 *  0.2 : Apr 24, 1991 - use substring portions of domain
 *  0.1 : Mar 18, 1991 - improved the trailing domain list
 *  0.0 : Feb 19, 1991 - pirated by Erick Engelke
 * -1.0 :              - NCSA code
 */

/*lint -w2 -e537 -e534 -epuc */

#include "copyrigh.h"
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <conio.h>
#include <tcp.h>

#define	PRIVATE static
#define	BOOL	int
#define	FALSE	0
#define	TRUE	1

#define	MAXUDPLEN	512	/* maximum length of a UDP packet	*/
#define	MAXDOMLEN	256	/* maximum length of a domain name	*/

/*
 *  Header for the DOMAIN queries
 *  ALL OF THESE ARE BYTE SWAPPED QUANTITIES!
 *  We are the poor slobs who are incompatible with the world's byte order
 */
typedef struct DHEAD
	{
	word		ident   ;	/* unique identifier		*/
	word		flags   ;
	word		qdcount ;	/* question section, # entries	*/
	word		ancount ;	/* answers, how many		*/
	word		nscount ;	/* count of name server RRs	*/
	word		arcount ;	/* # of "additional" records	*/
	} DHEAD ;

/*
 *  data for domain name lookup
 */
typedef struct USEEK
	{
	DHEAD		h ;
	byte		x[MAXUDPLEN - sizeof(DHEAD)] ;
	} USEEK ;

/*
 *  a resource record is made up of a compressed domain name followed by
 *  this structure.  All of these ints need to be byteswapped before use.
 */
typedef struct RRPART
	{
	word	   	rtype    ;	/* resource record type		*/
	word		rclass   ;	/* RR class			*/
	longword	ttl      ;	/* 32 bit time-to-live		*/
	word		rdlength ;	/* length of next field		*/
	byte	 	rdata[1] ;	/* data field			*/
	} RRPART ;

/*
 *  flag masks for the flags field of the DOMAIN header
 */
#define DQR		0x8000	/* query = 0, response = 1		*/
#define DOPCODE		0x7800	/* opcode, see below			*/
#define DAA		0x0400	/* Authoritative answer			*/
#define DTC		0x0200	/* Truncation, response cut off at 512	*/
#define DRD		0x0100	/* Recursion desired			*/
#define DRA		0x0080	/* Recursion available			*/
#define DRCODE		0x000F	/* response code, see below		*/

/* opcode possible values: */
#define DOPQUERY	0	/* a standard query			*/
#define DOPIQ		1	/* an inverse query			*/
#define DOPCQM		2	/* a completion query, multiple reply	*/
#define DOPCQU		3     	/* a completion query, single reply	*/
/* the rest reserved for future */

/* legal response codes: */
#define DROK		0	/* okay response			*/
#define DRFORM		1	/* format error				*/
#define DRFAIL		2	/* their problem, server failed		*/
#define DRNAME		3	/* name error, we know name don't exist	*/
#define DRNOPE		4	/* no can do request			*/
#define DRNOWAY		5	/* name server refusing to do request	*/

/*
 Vlaues found in a resource record type field.
 */
#define DTYPEA		1	/* host address resource record (RR)	*/
#define	DTYPENS		2	/* An authoritative name server		*/
#define	DTYPEMD		3	/* a mail destination			*/
#define	DTYPEMF		4	/* a mail forwarder			*/
#define	DTYPECNAME	5	/* the canonical name for an alias	*/
#define	DTYPESOA	6	/* marks the start of a zone of auth.	*/
#define	DTYPEMB		7	/* a mailbox domain name		*/
#define	DTYPEMG		8	/* a mail group member			*/
#define	DTYPEMR		9	/* a mail rename domain name		*/
#define	DTYPENULL	10	/* a null RR				*/
#define	DTYPEWKS	11	/* a well known service description	*/
#define DTYPEPTR	12	/* a domain name ptr			*/
#define	DTYPEHINFO	13	/* host information			*/
#define	DTYPEMINFO	14	/* mailbox or mail list information	*/
#define	DTYPEMX		15	/* a mailer MX record			*/

#define DIN		1	/* ARPA internet class			*/
#define DWILD		255	/* wildcard for several classifications	*/

/*
 * Nameserver search strategies ...
 */
#define	DNS_DEFAULT		0
#define	DNS_FULLY_SPECIFIED	1
#define	DNS_MAP_LOCAL_NAMES	2
#define	DNS_RECOGNIZED_ROOT	3

/*
 * function prototypes ...
 */

PRIVATE unsigned	Process_Response(USEEK *, byte, void *)		;
PRIVATE unsigned	DNS_Query(char *, byte, void *, void (*)())	;
PRIVATE char *		nextdomain(char *, int)				;
PRIVATE USEEK *		Prepare_Question(char *, char *, byte, int *)	;
PRIVATE int		Encode_Name(char *)				;
PRIVATE BOOL		Send_Question(udp_Socket*, USEEK*, int,
				longword, void (*)())			;
PRIVATE int		Decode_Name(char *, char *, USEEK *)		;
PRIVATE void *		Unpack(byte, void *, void *, USEEK *)		;
PRIVATE BOOL		Well_Defined(char *)				;

/* ---------------------------------------------- */
/* Global 'constants' loaded from WATTCP.CFG file */
/* ---------------------------------------------- */
char *		def_domain				= "" ;
longword	def_nameservers[MAX_NAMESERVERS]	= {0L} ;
int		_last_nameserver			= 0 ;
word		_domaintimeout				= 0 ;
int		_dns_search_mode			= 0 ;

extern void (*system_yield)() ;

/*********************************************************************/
/*  Encode_Name
*   Encode a regular text string into a packed domain name, suitable
*   for the name server.
*
*   returns total length used
*/
PRIVATE int Encode_Name(char *data)
	{
	char *period ;
	int total ;

	total = 0 ;

	do
		{
		int len ;

		if (period = strchr(data, '.')) *period = '\0' ;
		len = strlen(data) ;
		if (len > 0x3F) return -1 ;
		total += len + 1 ;
		if (total > MAXDOMLEN) return -1 ;
		data[-1] = (char) len ;
		data = period + 1 ;
		} while (period) ;

	return total + 1 ;
	}

/*********************************************************************/
/*  Decode_Name
*  Unpack a compressed domain name that we have received from another
*  host.  Handles pointers to continuation domain names -- buf is used
*  as the base for the offset of any pointer which is present.
*  returns the number of bytes at src which should be skipped over.
*  Includes the NULL terminator in its length count.
*/
PRIVATE int Decode_Name(char *dst, char *src, USEEK *buf)
	{
	int i, j, retval, len ;
	char *savesrc ;

	savesrc = src ;
	retval = len = 0 ;

	while (j = *src)
		{
		while ((j & 0xC0) == 0xC0) /* pointer to prior occurence */
			{
			if (!retval) retval = src - savesrc + 2 ;
			src = (char *) buf + ((j & 0x3F) << 8) + src[1] ;
			j = *src ;
			}

		src++ ;
		j &= 0x3F ;
		if (dst && (len += 1 + j) > MAXDOMLEN) goto done ;
		for (i = 0; i < j; i++)
			{
			char c = *src++ ;
			if (dst) *dst++ = c ;
			}
		if (dst) *dst++ = '.' ;
		}

	if (dst) dst[-1] = '\0' ; /* add terminator */
done:
	return retval ? retval : 1 + src - savesrc ;
	}

PRIVATE void *Unpack(byte dtype, void *src, void *dst, USEEK *qp)
	{
	switch (dtype)
		{
		case DTYPEA: /* Address record */
			*((longword *) dst) = *((longword *) src) ;
			break ;

		case DTYPEMX:
			/* Get preference, then hostname */
			*((word *) dst)++ = intel16(*((word *) src)++) ;
			(void) Decode_Name(dst, src, qp) ;
			return (char *) dst + strlen(dst) + 1 ;

		case DTYPEPTR:
			(void) Decode_Name(dst, src, qp) ;
			break ;
		}

	return NULL ;
	}

/*********************************************************************/
/*  Process_Response
*   extract the data from a response message.
*   returns the appropriate status code and if the data is available,
*   copies it into data
*   dtype is the RR type
*/
PRIVATE unsigned Process_Response(USEEK *qp, byte dtype, void *data)
	{
	unsigned answer, answers, found ;
	RRPART *rrp ;
	byte *p ;

	/* return code for this message*/
	if (DRCODE & intel16(qp->h.flags)) return 0 ;

	/* number of answers */
	answers = intel16(qp->h.ancount) ;

	/* at least one answer & response flag must be set */
	if (!answers || (intel16(qp->h.flags) & DQR) == 0) return 0 ;

	p = qp->x ;

	/*  spec defines name then  QTYPE + QCLASS = 4 bytes */
	p += Decode_Name(NULL, p, qp) + 4 ; /* unpack name */

	found = 0 ;
	for (answer = 0; answer < answers; answer++)
		{
		/* answer name to unpack; account for string */
		p += Decode_Name(NULL, p, qp) ;

		rrp = (RRPART *) p ;	/* resource record here */

		/* correct type and class? */
		if (intel16(rrp->rtype)==dtype && intel16(rrp->rclass)==DIN)
		    	{
			/* get data we're looking for */
			found++ ;
			data = Unpack(dtype, rrp->rdata, data, qp) ;
			if (!data) break ;
			}

		p += 10 + intel16(rrp->rdlength) ;
		}

	return found ;
	}

PRIVATE USEEK *Prepare_Question(char *host, char *domain, byte dtype, int *n)
	{
	USEEK *question ;
	char *namebuff ;
	RRPART *rrp ;

	/* kill leading spaces */
	while (*host && *host <= ' ') host++ ;
	if (!*host) return NULL ;

	question = (USEEK *) malloc(sizeof(USEEK)) ;
	if (!question)
		{
		outs("Can't allocate memory for DNS question!\r\n") ;
		return NULL ;
		}

	strcpy(namebuff = (char *) &question->x[1], host) ;
	if (domain != NULL)
		{
		strcat(namebuff, ".") ;
		strcat(namebuff, domain) ;
		}

	if ((*n = Encode_Name(namebuff)) == -1)
		{
		outs("Can't run-length encode domain name!\r\n") ;
		free(question) ;
		return NULL ;
		}

	question->h.ident = intel16(0xF001) ;
	question->h.flags = intel16(DRD) ;
	question->h.qdcount = intel16(1) ;
	question->h.ancount = 0 ;
	question->h.nscount = 0 ;
	question->h.arcount = 0 ;

	rrp = (RRPART *) &(question->x[*n]) ;
	rrp->rtype = intel16(dtype) ;
	rrp->rclass = intel16(DIN) ;
	*n += sizeof(DHEAD) + 4 ;

	return question ;
	}

/**************************************************************************/
/*  Send_Question
*   DOMAIN based name lookup
*   query a domain name server to get resource record data
*	Returns the data on a machine from a particular RR type.
*   Events generated will have this number tagged with them.
*   Returns various negative numbers on error conditions.
*
*   if loc_domain is non-NULL, add default domain
*
*   Returns true if we got data, false otherwise.
*/
PRIVATE BOOL Send_Question(udp_Socket *sckt, USEEK *question, int n,
	longword total, void (*yield)())
	{
	int secs ;

	/*
	 * This is not terribly good, but it attempts to use a binary
	 * exponentially increasing delays.
	 */
	for (secs = 2; secs <= 16; secs *= 2)
		{
		longword timer = set_timeout(secs) ;
		sock_write(sckt, (byte *) question, n) ;
		for (;;)
			{
			if (yield) (*yield)() ;
			chk_ctlc() ;
			tcp_tick(sckt) ;
			if (watcbroke) break ;
			if (chk_timeout(timer)) break ;
			if (chk_timeout(total)) break ;
			if (sock_dataready(sckt)) return TRUE ;
			}
		}

	return FALSE ;
	}

/*
 * nextdomain - given domain and count = 0,1,2,..., return next larger
 *		domain or NULL when no more are available
 */
PRIVATE char *nextdomain(char *domain, int count)
	{
	char *p;
	int i;

	p = domain;
	for (i = 0; i < count; ++i)
		{
		p = strchr(p, '.') ;
		if (!p) break ;
		++p ;
		}
	return p ;
	}

PRIVATE BOOL Well_Defined(char *remote_name)
	{
	static char *domains[] =
		{
		"com",	"edu",	"gov",	"mil",
		"net",	"org",	"nato",	"arpa"
		} ;
	unsigned i ;
	char *p ;

	if (strstr(remote_name, ".IN-ADDR.ARPA")) return TRUE ;

	p = strrchr(remote_name, '.') ;
	switch (_dns_search_mode)
		{
		case DNS_FULLY_SPECIFIED:
			return TRUE ;

		case DNS_MAP_LOCAL_NAMES:
			return p != NULL ;

		case DNS_RECOGNIZED_ROOT:
			if (!p++) return 0 ;
			for (i = 0; i < sizeof(domains)/sizeof(char *); i++)
				{
				if (!strcmpi(p, domains[i])) return TRUE ;
				}
			break ;
		}

	return FALSE ;
	}

/*
 * Perform a nameserver lookup of specified type using specified
 *    unpacker to extract data, if found.
 */
PRIVATE unsigned DNS_Query(char *name, byte dtype, void *data,void (*yield)())
	{
	BOOL _timeout[MAX_NAMESERVERS] ;
	udp_Socket *sckt ;
	word oldhndlcbrk ;
	unsigned answers ;
	longword total ;
	int count ;

	if (!name) return 0 ;
	rip(name) ;

	if (!_domaintimeout) _domaintimeout = sock_delay << 2 ;
	total = set_timeout(_domaintimeout) ;

	count = 0 ;
	memset(_timeout, FALSE, sizeof(_timeout)) ;

	if ((sckt = udp_socket()) == NULL)
		{
		outs("Can't allocate memory for DNS socket!\r\n") ;
		return 0 ;
		}

	answers = 0 ;
	oldhndlcbrk = wathndlcbrk ;
	wathndlcbrk = 1 ;        /* enable special interrupt mode */
	watcbroke = 0 ;
	do
		{
		char *loc_domain ;
		USEEK *question ;
		int i, n ;

		if (Well_Defined(name)) loc_domain = NULL ;
		else loc_domain = nextdomain(def_domain, count++) ;
		if (!loc_domain && !strchr(name, '.')) break ;

		question = Prepare_Question(name, loc_domain, dtype, &n) ;
		if (!question) break ;

 		for (i = 0; i < _last_nameserver; ++i)
			{
			if (_timeout[i]) continue ;

			udp_open(sckt, 0, def_nameservers[i], 53, NULL) ;

			if (Send_Question(sckt,question,n,total,yield))
				{
				/* read & process the received data */
				sock_fastread(sckt, (byte *) question,
					sizeof(USEEK)) ;
				answers = Process_Response(question, dtype,
						data) ;
				}
			else _timeout[i] = TRUE ;
			sock_close(sckt) ;
			if (answers) break ;
			}

		free(question) ;
		if (!loc_domain) break ;
		} while (!answers) ;

	/* always clean up */
	free_socket(sckt) ;
	watcbroke = 0 ;
	wathndlcbrk = oldhndlcbrk ;
	return answers ;
	}

/*
 * resolve()
 * 	convert domain name -> address resolution.
 * 	returns 0 if name is unresolvable right now
 */
longword resolve(char *name)
	{
	return _resolve(name, system_yield) ;
	}

longword _resolve(char *name, void (*yield)())
	{
	longword ipaddr ;

	if (!name) return 0L ;

	if (isaddr(name)) return aton(name) ;

	if (!DNS_Query(name, DTYPEA, &ipaddr, yield)) return 0L ;

	return intel(ipaddr) ;
	}

/*
 * reverse_addr_lookup()
 *    lookup a hostname based on IP address
 *          (PTR lookups in the .in-addr.arpa domain)
 *
 * Returns true if the info was found, false otherwise.
 *
 * assumes: name buffer is big enough for the longest hostname
 */
BOOL reverse_addr_lookup(longword ipaddr, char *name)
	{
	return _reverse_addr_lookup(ipaddr, name, system_yield) ;
	}

BOOL _reverse_addr_lookup(longword ipaddr, char *name, void (*yield)())
	{
	char revname[30] ;

	inet_ntoa(revname, ntohl(ipaddr)) ;   /* ntohl flips order */
	strcat(revname, ".IN-ADDR.ARPA") ;
	return DNS_Query(revname, DTYPEPTR, name, yield) != 0 ;
	}

unsigned MX_LookUp(char *hostname, void *mx_records, void (*yield)())
	{
	return DNS_Query(hostname, DTYPEMX, mx_records, yield) ;
	}
